module casper.casper {
   import:
   (TargetRef = data.ref.backtrackable:new('none')) >>
   module [TargetRef] {

      target = TargetRef.

      execute_cmdline :-
         FileQueue = data.queue:new(),
         sys.cmdline:parse() {
            default(_) :-
               fail.

            long(Long, Next) :-
               Long match (
                  'target'
               ->
                  target:set('some'(Next:get))
               ).

            file(Filename) :-
               FileQueue:add(Filename).
         },
         target:get match (
            'none'
         ->
            throw('error'('No target specified'))
         ;
            'some'(Target)
         ->
            FileQueue:iter(casper.compiler:compile_file(*, Target))
         ).
   }.

   main :-
      casper.codegen.choco:dummy,
      catch(execute_cmdline, E, casper.error:fatal(E)).
}